// ////////////////////////////////////////////////////////
// Lecture on the CORBA Component Model, summer term 2003
// Assignment 7, Stephan Brumme, 702544
//
// Microsoft .NET server that exports a "reverse" operation 
//

// for console output
using System;

// remoting
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

// reverse operation
using ReverseAPI;


namespace Aufgabe7
{
	/// <summary>
	/// The server class registers itself at port 8421
	/// </summary>
	class Server
	{
		static void Main()
		{
			// reserve port 8421
			ChannelServices.RegisterChannel(new TcpServerChannel(8421));

			// register the implementation (clients access it through the interface !)
			// using the URI "ReverserServer" and SingleCall activation
			RemotingConfiguration.RegisterWellKnownServiceType(typeof(ReverserImplementation), "ReverserServer", 
				WellKnownObjectMode.SingleCall);

			// and wait for incoming requests ...
			Console.WriteLine("Server ready ... press Enter to terminate !");
			Console.ReadLine();
		}
	}
}